// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once
#include "ISCW_UClass.h"
#include "ISCW_UK2Node.h"

#include <memory>
#include <string>

using std::shared_ptr;
using std::wstring;

namespace Sourcify
{
	class ISCW_UClass;
	class ISCW_UK2Node_DynamicCast : public virtual ISCW_UK2Node
	{
	public:
		virtual ~ISCW_UK2Node_DynamicCast() = default;

		virtual shared_ptr<ISCW_UClass> GetTargetType() const = 0;

		virtual void SetTargetType(shared_ptr<ISCW_UClass> InTargetType) = 0;
		
		virtual std::shared_ptr<ISCW_UK2Node_DynamicCast> ToUK2Node_DynamicCastPtr() = 0;
		virtual std::shared_ptr<const ISCW_UK2Node_DynamicCast> ToUK2Node_DynamicCastPtr() const = 0;
	};

	using ISCW_UK2Node_DynamicCastConstPtr = std::shared_ptr<const ISCW_UK2Node_DynamicCast>;
	using ISCW_UK2Node_DynamicCastPtr = std::shared_ptr<ISCW_UK2Node_DynamicCast>;
} // namespace Sourcify